org.apache.lucene.search.spans

## Class FieldMaskingSpanQuery

- java.lang.Object
- - org.apache.lucene.search.Query
  - - org.apache.lucene.search.spans.SpanQuery
    - - org.apache.lucene.search.spans.FieldMaskingSpanQuery

- All Implemented Interfaces:
    Cloneable

      public class FieldMaskingSpanQuery
      extends SpanQuery

  Wrapper to allow `SpanQuery` objects participate in composite single-field SpanQueries by 'lying' about their search field. That is, the masked SpanQuery will function as normal, but `SpanQuery.getField()` simply hands back the value supplied in this class's constructor.

  This can be used to support Queries like `SpanNearQuery` or `SpanOrQuery` across different fields, which is not ordinarily permitted.

  This can be useful for denormalized relational data: for example, when indexing a document with conceptually many 'children':

        teacherid: 1
        studentfirstname: james
        studentsurname: jones

        teacherid: 2
        studenfirstname: james
        studentsurname: smith
        studentfirstname: sally
        studentsurname: jones

  a SpanNearQuery with a slop of 0 can be applied across two `SpanTermQuery` objects as follows:

          SpanQuery q1  = new SpanTermQuery(new Term("studentfirstname", "james"));
          SpanQuery q2  = new SpanTermQuery(new Term("studentsurname", "jones"));
          SpanQuery q2m = new FieldMaskingSpanQuery(q2, "studentfirstname");
          Query q = new SpanNearQuery(new SpanQuery[]{q1, q2m}, -1, false);

  to search for 'studentfirstname:james studentsurname:jones' and find teacherid 1 without matching teacherid 2 (which has a 'james' in position 0 and 'jones' in position 1).

  Note: as `getField()` returns the masked field, scoring will be done using the Similarity and collection statistics of the field name supplied, but with the term statistics of the real field. This may lead to exceptions, poor performance, and unexpected scoring behaviour.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `FieldMaskingSpanQuery(SpanQuery maskedQuery, String maskedField)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Weight` | `createWeight(IndexSearcher searcher)` Expert: Constructs an appropriate Weight implementation for this query.
    `boolean` | `equals(Object o)`
    `void` | `extractTerms(Set<Term> terms)` Expert: adds all terms occurring in this query to the terms set.
    `String` | `getField()` Returns the name of the field matched by this query.
    `SpanQuery` | `getMaskedQuery()`
    `Spans` | `getSpans(AtomicReaderContext context, Bits acceptDocs, Map<Term,TermContext> termContexts)` Expert: Returns the matches for this query in an index.
    `int` | `hashCode()`
    `Query` | `rewrite(IndexReader reader)` Expert: called to re-write queries into primitive queries.
    `String` | `toString(String field)` Prints a query to a string, with `field` assumed to be the default field and omitted.

    - ### Methods inherited from class org.apache.lucene.search.Query

      `clone, getBoost, setBoost, toString`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### FieldMaskingSpanQuery

          public FieldMaskingSpanQuery(SpanQuery maskedQuery,
                               String maskedField)

  - ### Method Detail

    - #### getField

          public String getField()

      Description copied from class: `SpanQuery`
      Returns the name of the field matched by this query.
      Specified by:
        `getField` in class `SpanQuery`

    - #### getMaskedQuery

          public SpanQuery getMaskedQuery()

    - #### getSpans

          public Spans getSpans(AtomicReaderContext context,
                       Bits acceptDocs,
                       Map<Term,TermContext> termContexts)
                         throws IOException

      Description copied from class: `SpanQuery`
      Expert: Returns the matches for this query in an index. Used internally to search for spans.
      Specified by:
        `getSpans` in class `SpanQuery`
      Throws:
        `IOException`

    - #### extractTerms

          public void extractTerms(Set<Term> terms)

      Description copied from class: `Query`
      Expert: adds all terms occurring in this query to the terms set. Only works if this query is in its `rewritten` form.
      Overrides:
        `extractTerms` in class `Query`

    - #### createWeight

          public Weight createWeight(IndexSearcher searcher)
                              throws IOException

      Description copied from class: `Query`
      Expert: Constructs an appropriate Weight implementation for this query.

      Only implemented by primitive queries, which re-write to themselves.

      Overrides:
        `createWeight` in class `SpanQuery`
      Throws:
        `IOException`

    - #### rewrite

          public Query rewrite(IndexReader reader)
                        throws IOException

      Description copied from class: `Query`
      Expert: called to re-write queries into primitive queries. For example, a PrefixQuery will be rewritten into a BooleanQuery that consists of TermQuerys.
      Overrides:
        `rewrite` in class `Query`
      Throws:
        `IOException`

    - #### toString

          public String toString(String field)

      Description copied from class: `Query`
      Prints a query to a string, with `field` assumed to be the default field and omitted.
      Specified by:
        `toString` in class `Query`

    - #### equals

          public boolean equals(Object o)

      Overrides:
        `equals` in class `Query`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Query`

Copyright © 2000-2013 Apache Software Foundation. All Rights Reserved.